import "core-js/modules/es.array.map";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.values";
import { fetch, cancel, fetchSuccess, fetchError } from './actions';
import { KEYS, PATHS } from './constants';
import reducer from './reducers';
var dataKey = KEYS.DATA,
    errorKey = KEYS.ERROR,
    pendingKey = KEYS.PENDING;
var expectedInitialState = Object.assign.apply(Object, Object.values(PATHS).map(function (reducerPath) {
  var _ref;

  return _ref = {}, _ref[reducerPath] = {}, _ref;
}));
var id = 12345;
var path = PATHS.ITEMS;
describe('reducers', function () {
  it('should return correct initial state', function () {
    expect(reducer(undefined, {})).toEqual(expectedInitialState);
  });
  describe('fetchReducer', function () {
    it('should return correct state for fetch action', function () {
      var _id, _Object$assign, _Object$assign2;

      expect(reducer(undefined, fetch({
        id: id,
        path: path
      }))).toEqual(Object.assign({}, expectedInitialState, (_Object$assign2 = {}, _Object$assign2[path] = Object.assign({}, expectedInitialState[path], (_Object$assign = {}, _Object$assign[id] = (_id = {}, _id[errorKey] = null, _id[pendingKey] = 1, _id), _Object$assign)), _Object$assign2)));
    });
  });
  describe('cancelReducer', function () {
    it('should return correct state for cancel action', function () {
      var _id2, _Object$assign3, _Object$assign4;

      expect(reducer(undefined, cancel({
        id: id,
        path: path
      }))).toEqual(Object.assign({}, expectedInitialState, (_Object$assign4 = {}, _Object$assign4[path] = Object.assign({}, expectedInitialState[path], (_Object$assign3 = {}, _Object$assign3[id] = (_id2 = {}, _id2[pendingKey] = -1, _id2), _Object$assign3)), _Object$assign4)));
    });
  });
  describe('fetchSuccessReducer', function () {
    it('should return correct state for fetchSuccess action', function () {
      var _fetchSuccess, _id3, _Object$assign5, _Object$assign6;

      var data = 'data';
      expect(reducer(undefined, fetchSuccess((_fetchSuccess = {
        id: id,
        path: path
      }, _fetchSuccess[dataKey] = data, _fetchSuccess)))).toEqual(Object.assign({}, expectedInitialState, (_Object$assign6 = {}, _Object$assign6[path] = Object.assign({}, expectedInitialState[path], (_Object$assign5 = {}, _Object$assign5[id] = (_id3 = {}, _id3[dataKey] = data, _id3[errorKey] = null, _id3[pendingKey] = -1, _id3), _Object$assign5)), _Object$assign6)));
    });
  });
  describe('fetchErrorReducer', function () {
    it('should return correct state for fetchError action', function () {
      var _fetchError, _id4, _Object$assign7, _Object$assign8;

      var error = {
        message: 'error'
      };
      expect(reducer(undefined, fetchError((_fetchError = {
        id: id,
        path: path
      }, _fetchError[errorKey] = error, _fetchError)))).toEqual(Object.assign({}, expectedInitialState, (_Object$assign8 = {}, _Object$assign8[path] = Object.assign({}, expectedInitialState[path], (_Object$assign7 = {}, _Object$assign7[id] = (_id4 = {}, _id4[dataKey] = null, _id4[errorKey] = error.message, _id4[pendingKey] = -1, _id4), _Object$assign7)), _Object$assign8)));
    });
  });
});