import "core-js/modules/es.array.includes";
import "core-js/modules/es.date.to-string";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.regexp.to-string";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import "regenerator-runtime/runtime";

var _marked =
/*#__PURE__*/
_regeneratorRuntime.mark(sendRequest),
    _marked2 =
/*#__PURE__*/
_regeneratorRuntime.mark(cancelRequest),
    _marked3 =
/*#__PURE__*/
_regeneratorRuntime.mark(saga);

import { delay } from 'redux-saga';
import { take, fork, call, put, cancel as cancelEffect, cancelled, race, join } from 'redux-saga/effects';
import axios from 'axios';
import { fetch, cancel, fetchSuccess, fetchError } from './actions';
import { BASE_URL as baseURL, KEYS } from './constants';
var create = axios.create,
    CancelToken = axios.CancelToken;
var axiosInstance = create({
  baseURL: baseURL
});
var dataKey = KEYS.DATA,
    errorKey = KEYS.ERROR;
var cancelType = cancel.toString();
var maxRetries = 10;
var retriableStatusCodes = [429, 500];

var getJitter = function getJitter() {
  return Math.floor(Math.random() * 1001) - 500;
};

function sendRequest(_ref) {
  var _ref$payload, id, path, abortSource, i, _fetchSuccess, _ref2, data, status, _fetchError, message, _error$response, _status, _error$response$data, text;

  return _regeneratorRuntime.wrap(function sendRequest$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _ref$payload = _ref.payload, id = _ref$payload.id, path = _ref$payload.path;
          _context.prev = 1;
          i = 0;

        case 3:
          if (!(i < maxRetries)) {
            _context.next = 27;
            break;
          }

          _context.prev = 4;
          abortSource = CancelToken.source();
          _context.next = 8;
          return call([axiosInstance, 'get'], "/" + path + "/" + id + "?lang=en", {
            cancelToken: abortSource.token
          });

        case 8:
          _ref2 = _context.sent;
          data = _ref2.data;
          _context.next = 12;
          return put(fetchSuccess((_fetchSuccess = {
            id: id,
            path: path
          }, _fetchSuccess[dataKey] = data, _fetchSuccess)));

        case 12:
          return _context.abrupt("return");

        case 15:
          _context.prev = 15;
          _context.t0 = _context["catch"](4);
          status = _context.t0.response.status;

          if (!(i < maxRetries - 1 && retriableStatusCodes.includes(status))) {
            _context.next = 23;
            break;
          }

          _context.next = 21;
          return call(delay, Math.pow(2, i) * 1000 + getJitter());

        case 21:
          _context.next = 24;
          break;

        case 23:
          throw _context.t0;

        case 24:
          i += 1;
          _context.next = 3;
          break;

        case 27:
          _context.next = 38;
          break;

        case 29:
          _context.prev = 29;
          _context.t1 = _context["catch"](1);
          message = _context.t1.message, _error$response = _context.t1.response;
          _error$response = _error$response === void 0 ? {} : _error$response;
          _status = _error$response.status, _error$response$data = _error$response.data;
          _error$response$data = _error$response$data === void 0 ? {} : _error$response$data;
          text = _error$response$data.text;
          _context.next = 38;
          return put(fetchError((_fetchError = {
            id: id,
            path: path
          }, _fetchError[errorKey] = {
            message: text || message,
            status: _status
          }, _fetchError)));

        case 38:
          _context.prev = 38;
          _context.next = 41;
          return cancelled() && !abortSource;

        case 41:
          if (!_context.sent) {
            _context.next = 44;
            break;
          }

          _context.next = 44;
          return call([abortSource, 'cancel']);

        case 44:
          return _context.finish(38);

        case 45:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, null, [[1, 29, 38, 45], [4, 15]]);
}

function cancelRequest(_ref3, fetchTask) {
  var fetchId, fetchPath, _ref4, abortingAction;

  return _regeneratorRuntime.wrap(function cancelRequest$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          fetchId = _ref3.id, fetchPath = _ref3.path;
          _context2.next = 3;
          return race({
            taskFinished: join(fetchTask),
            abortingAction: take(function (_ref5) {
              var type = _ref5.type,
                  _ref5$payload = _ref5.payload,
                  id = _ref5$payload.id,
                  path = _ref5$payload.path;
              return type === cancelType && fetchId === id && fetchPath === path;
            }) // timeout: call(delay, 90000), // taskFinished doesnt work for aborted tasks

          });

        case 3:
          _ref4 = _context2.sent;
          abortingAction = _ref4.abortingAction;

          if (!abortingAction) {
            _context2.next = 8;
            break;
          }

          _context2.next = 8;
          return cancelEffect(fetchTask);

        case 8:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2);
}

export default function saga() {
  var action, fetchTask;
  return _regeneratorRuntime.wrap(function saga$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          if (!true) {
            _context3.next = 11;
            break;
          }

          _context3.next = 3;
          return take(fetch);

        case 3:
          action = _context3.sent;
          _context3.next = 6;
          return fork(sendRequest, action);

        case 6:
          fetchTask = _context3.sent;
          _context3.next = 9;
          return fork(cancelRequest, action.payload, fetchTask);

        case 9:
          _context3.next = 0;
          break;

        case 11:
        case "end":
          return _context3.stop();
      }
    }
  }, _marked3);
}