"use strict";

require("core-js/modules/es.array.map");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.values");

exports.__esModule = true;
exports["default"] = void 0;

var _reduxActions = require("redux-actions");

var _actions = require("./actions");

var _constants = require("./constants");

var _handleActions;

var dataKey = _constants.KEYS.DATA,
    errorKey = _constants.KEYS.ERROR,
    pendingKey = _constants.KEYS.PENDING;

var _default = (0, _reduxActions.handleActions)((_handleActions = {}, _handleActions[_actions.fetch] = function (state, _ref) {
  var _id, _Object$assign, _Object$assign2;

  var _ref$payload = _ref.payload,
      id = _ref$payload.id,
      path = _ref$payload.path;
  return Object.assign({}, state, (_Object$assign2 = {}, _Object$assign2[path] = Object.assign({}, state[path], (_Object$assign = {}, _Object$assign[id] = (_id = {}, _id[errorKey] = null, _id[pendingKey] = (state[path][id] && state[path][id][pendingKey] || 0) + 1, _id), _Object$assign)), _Object$assign2));
}, _handleActions[_actions.cancel] = function (state, _ref2) {
  var _id2, _Object$assign3, _Object$assign4;

  var _ref2$payload = _ref2.payload,
      id = _ref2$payload.id,
      path = _ref2$payload.path;
  return Object.assign({}, state, (_Object$assign4 = {}, _Object$assign4[path] = Object.assign({}, state[path], (_Object$assign3 = {}, _Object$assign3[id] = (_id2 = {}, _id2[pendingKey] = (state[path][id] && state[path][id][pendingKey] || 0) - 1, _id2), _Object$assign3)), _Object$assign4));
}, _handleActions[_actions.fetchSuccess] = function (state, _ref3) {
  var _id3, _Object$assign5, _Object$assign6;

  var data = _ref3.payload,
      _ref3$meta = _ref3.meta,
      id = _ref3$meta.id,
      path = _ref3$meta.path;
  return Object.assign({}, state, (_Object$assign6 = {}, _Object$assign6[path] = Object.assign({}, state[path], (_Object$assign5 = {}, _Object$assign5[id] = (_id3 = {}, _id3[dataKey] = data, _id3[errorKey] = null, _id3[pendingKey] = (state[path][id] && state[path][id][pendingKey] || 0) - 1, _id3), _Object$assign5)), _Object$assign6));
}, _handleActions[_actions.fetchError] = function (state, _ref4) {
  var _id4, _Object$assign7, _Object$assign8;

  var error = _ref4.payload,
      _ref4$meta = _ref4.meta,
      id = _ref4$meta.id,
      path = _ref4$meta.path;
  return Object.assign({}, state, (_Object$assign8 = {}, _Object$assign8[path] = Object.assign({}, state[path], (_Object$assign7 = {}, _Object$assign7[id] = (_id4 = {}, _id4[dataKey] = null, _id4[errorKey] = error, _id4[pendingKey] = (state[path][id] && state[path][id][pendingKey] || 0) - 1, _id4), _Object$assign7)), _Object$assign8));
}, _handleActions), Object.assign.apply(Object, Object.values(_constants.PATHS).map(function (path) {
  var _ref5;

  return _ref5 = {}, _ref5[path] = {}, _ref5;
})));

exports["default"] = _default;