"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.map");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.values");

var _actions = require("./actions");

var _constants = require("./constants");

var _reducers = _interopRequireDefault(require("./reducers"));

var dataKey = _constants.KEYS.DATA,
    errorKey = _constants.KEYS.ERROR,
    pendingKey = _constants.KEYS.PENDING;
var expectedInitialState = Object.assign.apply(Object, Object.values(_constants.PATHS).map(function (reducerPath) {
  var _ref;

  return _ref = {}, _ref[reducerPath] = {}, _ref;
}));
var id = 12345;
var path = _constants.PATHS.ITEMS;
describe('reducers', function () {
  it('should return correct initial state', function () {
    expect((0, _reducers["default"])(undefined, {})).toEqual(expectedInitialState);
  });
  describe('fetchReducer', function () {
    it('should return correct state for fetch action', function () {
      var _id, _Object$assign, _Object$assign2;

      expect((0, _reducers["default"])(undefined, (0, _actions.fetch)({
        id: id,
        path: path
      }))).toEqual(Object.assign({}, expectedInitialState, (_Object$assign2 = {}, _Object$assign2[path] = Object.assign({}, expectedInitialState[path], (_Object$assign = {}, _Object$assign[id] = (_id = {}, _id[errorKey] = null, _id[pendingKey] = 1, _id), _Object$assign)), _Object$assign2)));
    });
  });
  describe('cancelReducer', function () {
    it('should return correct state for cancel action', function () {
      var _id2, _Object$assign3, _Object$assign4;

      expect((0, _reducers["default"])(undefined, (0, _actions.cancel)({
        id: id,
        path: path
      }))).toEqual(Object.assign({}, expectedInitialState, (_Object$assign4 = {}, _Object$assign4[path] = Object.assign({}, expectedInitialState[path], (_Object$assign3 = {}, _Object$assign3[id] = (_id2 = {}, _id2[pendingKey] = -1, _id2), _Object$assign3)), _Object$assign4)));
    });
  });
  describe('fetchSuccessReducer', function () {
    it('should return correct state for fetchSuccess action', function () {
      var _fetchSuccess, _id3, _Object$assign5, _Object$assign6;

      var data = 'data';
      expect((0, _reducers["default"])(undefined, (0, _actions.fetchSuccess)((_fetchSuccess = {
        id: id,
        path: path
      }, _fetchSuccess[dataKey] = data, _fetchSuccess)))).toEqual(Object.assign({}, expectedInitialState, (_Object$assign6 = {}, _Object$assign6[path] = Object.assign({}, expectedInitialState[path], (_Object$assign5 = {}, _Object$assign5[id] = (_id3 = {}, _id3[dataKey] = data, _id3[errorKey] = null, _id3[pendingKey] = -1, _id3), _Object$assign5)), _Object$assign6)));
    });
  });
  describe('fetchErrorReducer', function () {
    it('should return correct state for fetchError action', function () {
      var _fetchError, _id4, _Object$assign7, _Object$assign8;

      var error = {
        message: 'error'
      };
      expect((0, _reducers["default"])(undefined, (0, _actions.fetchError)((_fetchError = {
        id: id,
        path: path
      }, _fetchError[errorKey] = error, _fetchError)))).toEqual(Object.assign({}, expectedInitialState, (_Object$assign8 = {}, _Object$assign8[path] = Object.assign({}, expectedInitialState[path], (_Object$assign7 = {}, _Object$assign7[id] = (_id4 = {}, _id4[dataKey] = null, _id4[errorKey] = error.message, _id4[pendingKey] = -1, _id4), _Object$assign7)), _Object$assign8)));
    });
  });
});